﻿/*
    Program demonstrující práci s rozhraním a jednorozměrným polem. 
*/

using System;

namespace Greetings
{
    interface IGreeting
    {
        string Language { get; set; }

        string Greet();
    }

    class EnglishGreeting : IGreeting
    {
        public string Language { get; set; }

        public EnglishGreeting(string g)
        {
            Language = g;
        }

        public string Greet()
        {
            return "Good morning";
        }
    }

    class CzechGreeting : IGreeting
    {
        public string Language { get; set; }

        public CzechGreeting(string g)
        {
            Language = g;
        }

        public string Greet()
        {
            return "Dobré ráno";
        }
    }

    class GermanGreeting : IGreeting
    {
        public string Language { get; set; }

        public GermanGreeting(string g)
        {
            Language = g;
        }

        public string Greet()
        {
            return "Guten Morgen";
        }
    }

    class Program
    {
        public static void WriteGreetings(IGreeting[] g)
        {
            // for (int i = 0; i < g.Length; i++)
            //   Console.WriteLine(g[i].Language + " pozdrav je " + g[i].Greet());

            foreach (IGreeting greet in g)
                Console.WriteLine(greet.Language + " pozdrav je " + greet.Greet());
        }

        static void Main(string[] args)
        {
            IGreeting[] Greetings = new IGreeting[3];

            Greetings[0] = new EnglishGreeting("Anglický");
            Greetings[1] = new CzechGreeting("Český");
            Greetings[2] = new GermanGreeting("Německý");

            WriteGreetings(Greetings);
        }
    }
}


