﻿/*
    Program ukazující použití indexeru a vyvolání výjimky. 
*/

using System;

namespace Indexer
{
    class Vector
    {
        public double X { get; set; }
        public double Y { get; set; }
        public double Z { get; set; }

        public Vector(double initX, double initY, double initZ)
        {
            X = initX;
            Y = initY;
            Z = initZ;
        }

        public override string ToString()
        {
            return "(" + X + ", " + Y + ", " + Z + ")";
        }

        public double this[int i]
        {
            get
            {
                switch (i)
                {
                    case 0: return X;
                    case 1: return Y;
                    case 2: return Z;
                    default:
                        throw new IndexOutOfRangeException
                        ("Přístup k neexistujícímu indexu");
                }
            }
            set
            {
                switch (i)
                {
                    case 0:
                        X = value;
                        break;
                    case 1:
                        Y = value;
                        break;
                    case 2:
                        Z = value;
                        break;
                    default:
                        throw new IndexOutOfRangeException
                        ("Přístup k neexistujícímu indexu");
                }
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Vector v = new Vector(10, 20, 30);

            Console.WriteLine("Zadaný vektor je {0}", v);
            Console.WriteLine();

            for (int i = 0; i < 3; i++)
            {
                Console.WriteLine("{0}. složka vektoru je {1}", i + 1, v[i]);
            }
            Console.WriteLine();

            v.X = 15;
            v[1] = 25;
            v.Z = 35;

            Console.WriteLine("Zadaný vektor je {0}", v);
            Console.WriteLine();

            try
            {
                v[3] = 45;
            }
            catch (IndexOutOfRangeException ex)
            {
                Console.WriteLine("Nastala výjimka " + ex.Message);
            }
        }
    }
}

