﻿/*
    Program pro násobení matic.
*/

using System;

namespace MatrixProduct
{
    class Matrix
    {
        public static void WriteMatrix(int[,] a)
        {
            for (int i = 0; i < a.GetLength(0); i++)
            {
                for (int j = 0; j < a.GetLength(1); j++)
                    Console.Write("{0,4}", a[i, j]);
                Console.WriteLine();
            }
        }

        public static int[,] CalcProduct(int[,] a, int[,] b)
        {
            int[,] c = new int[a.GetLength(0), b.GetLength(1)];

            for (int i = 0; i < a.GetLength(0); i++)
                for (int j = 0; j < b.GetLength(1); j++)
                {
                    c[i, j] = 0;
                    for (int k = 0; k < a.GetLength(1); k++)
                        c[i, j] += a[i, k] * b[k, j];
                }

            return c;
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            int[,] a = {
                         { 1, 2, -1,  0},
                         { 0, 1, -1, -7},
                         {-8, 0,  0, -5}
                       };

            int[,] b = {
                         { 3,  2},
                         {-4,  1},
                         { 1,  0},
                         {-2, -3}
                       };

            int[,] c;

            Console.WriteLine("Matice A:");
            Matrix.WriteMatrix(a);
            Console.WriteLine();

            Console.WriteLine("Matice B:");
            Matrix.WriteMatrix(b);
            Console.WriteLine();

            c = Matrix.CalcProduct(a, b);
            Console.WriteLine("Matice C = A * B:");
            Matrix.WriteMatrix(c);
        }
    }
}

