﻿/*
    Program znázorňující manipulaci se strukturou a třídou
    (dokumentuje rozdíl mezi hodnotovým a referenčním datovým typem).
*/

using System;

namespace Point
{
    struct Point
    {
        public int X { get; set; }
        public int Y { get; set; }
        public Point(int x, int y) : this()
        {
            X = x;
            Y = y;
        }
    }

    enum Color { White, Yellow, Red, Green, Gray, Blue, Black }

    class Dog
    {
        public Color Color { get; set; }

        public Dog(Color color)
        {
            Color = color;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Point pt1, pt2;
            Dog dog1, dog2;

            pt1 = new Point(4, 3);
            pt2 = new Point();
            dog1 = new Dog(Color.White);

            Console.WriteLine("Bod 1: [{0},{1}]", pt1.X, pt1.Y);
            Console.WriteLine("Bod 2: [{0},{1}]", pt2.X, pt2.Y);
            Console.WriteLine("Barva psa 1 je {0}", dog1.Color.ToString());

            Console.WriteLine();

            pt2 = pt1;
            dog2 = dog1;

            Console.WriteLine("Bod 1: [{0},{1}]", pt1.X, pt1.Y);
            Console.WriteLine("Bod 2: [{0},{1}]", pt2.X, pt2.Y);
            Console.WriteLine("Barva psa 1 je {0}", dog1.Color.ToString());
            Console.WriteLine("Barva psa 2 je {0}", dog2.Color.ToString());
            Console.WriteLine();

            pt2.X = 9;
            pt2.Y = 1;
            dog2.Color = Color.Gray;

            Console.WriteLine("Bod1 [{0},{1}]", pt1.X, pt1.Y);
            Console.WriteLine("Bod2 [{0},{1}]", pt2.X, pt2.Y);
            Console.WriteLine("Barva psa 1 je {0}", dog1.Color.ToString());
            Console.WriteLine("Barva psa 2 je {0}", dog2.Color.ToString());
            Console.WriteLine();
        }
    }
}


